# -*- coding: utf-8 -*-
"""
Correction du TD 4
"""

def renverse(s):
    chaine = ""
    n = len(s)
    for i in range(n):
        chaine = chaine + s[n - 1 - i]
    return chaine

def renverse2(s):
    return s[::-1]


def palindrome(s):
    return s == renverse(s)

def palindrome2(s):
    #on peut se contenter de ne parcourir qu'une seule fois la chaîne
    #dans les deux sens simultanément sans copier la chaîne.
    pal = True
    i = 0
    n = len(s)
    milieu = n // 2
    while i < milieu and pal:
        pal = s[i] == s[n - 1 - i]
        i += 1
    return pal


def egal_depuis(texte, motif, i):
    """
    Renvoie True ssi à partir de l'indice i inclus, texte commence par motif
    """
    return texte[i: i + len(motif)] == motif

def occurences(texte, motif):
    nb = 0
    for i in range(len(texte)):
        nb += egal_depuis(texte, motif, i)
    return nb


def nombre_de_mots(chaine):
    """
    Compte le nombre de mots composant cette chaîne. Retourne ce nombre.
    
    Les mots sont séparés par des espaces et rien d'autre. Mes excuses à votre prof
    de français, nous ferons simple pour commencer.
    """
    nb = 0
    lit_mot = False #sommes nous en train de lire les lettres d'un mot
    for c in chaine:
        if c == ' ':
            lit_mot = False
        else:
            if not lit_mot:
                nb = nb + 1
                lit_mot = True
    return nb

def nombre_de_mots2(chaine):
    return len(chaine.split())
